<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 " "
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Plugins
 */
/**************************************************************************/

class Valutes_Request extends A_Request
{
  function Action($action)
  {
    switch($action)
    { case "getaddform": $this->getAddForm(); break;
	  case "geteditform": $this->getEditForm(); break;
	  case "getaddcatform": $this->getAddCatForm(); break;
	  case "geteditcatform": $this->getEditCatForm(); break;
	  case "setsort": $this->setSort(); break;
    }
  }

  function getAddForm()
  {
    $form = new A_Form("plugin_valutes_add.tpl");
	$this->RESULT['html'] = $form->getContent();
  }

  function getEditForm()
  {
    $form = new A_Form("plugin_valutes_edit.tpl");
	$form->data=A::$DB->getRowById($_POST['id'],STRUCTURE);
	$this->RESULT['html'] = $form->getContent();
  }

  function getAddCatForm()
  {
    $form = new A_Form("plugin_valutes_addcat.tpl");
	$form->data['items']=A::$DB->getAll("SELECT * FROM ".STRUCTURE.(!empty($_POST['id'])?" WHERE id=".(integer)$_POST['id']:""));
	foreach($form->data['items'] as $i=>$row)
	{ $form->data['items'][$i]['namekurs']="kurs_".$row['name'];
	  $form->data['items'][$i]['nameper']="per_".$row['name'];
	}
	if($form->data['section']=getSectionByModule('shoplite'))
	$form->data['categories']=A::$DB->getAll("SELECT id,idker,name FROM {$form->data['section']}_categories ORDER BY level,sort");
	$this->RESULT['html'] = $form->getContent();
  }

  function getEditCatForm()
  {
    $form = new A_Form("plugin_valutes_editcat.tpl");
    $form->data['idcat']=$_POST['idcat'];
    $form->data['items']=A::$DB->getAll("SELECT * FROM ".STRUCTURE.(!empty($_POST['id'])?" WHERE id=".(integer)$_POST['id']:""));
    foreach($form->data['items'] as $i=>$row)
	{ $data=!empty($row['data'])?unserialize($row['data']):array();
	  $form->data['items'][$i]['namekurs']="kurs_".$row['name'];
	  $form->data['items'][$i]['nameper']="per_".$row['name'];
	  $form->data['items'][$i]['kurs']=isset($data[$_POST['idcat']]['kurs'])?$data[$_POST['idcat']]['kurs']:1;
	  $form->data['items'][$i]['per']=isset($data[$_POST['idcat']]['per'])?$data[$_POST['idcat']]['per']:0;
    }
    if($form->data['section']=getSectionByModule('shoplite'))
	$form->data['categories']=A::$DB->getAll("SELECT id,idker,name FROM {$form->data['section']}_categories ORDER BY level,sort");
	$this->RESULT['html'] = $form->getContent();
  }

  function setSort()
  {
    $sort=!empty($_POST['sort'])?explode(",",$_POST['sort']):array();
	$i=1;
	foreach($sort as $id)
	A::$DB->Update(STRUCTURE,array('sort'=>$i++),"id=".(integer)$id);
  }
}

A::$REQUEST = new Valutes_Request;