<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 " "
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Plugins
 */
/**************************************************************************/

function valutes_prepareValues($section,$data)
{ static $valutes=null;
  static $categories=array();

  if(!empty($_REQUEST['action']) && $_REQUEST['action']=='order')
  return $data;

  if(is_null($valutes))
  { if($structure=getStructureByPlugin('valutes'))
    $valutes=A::$DB->getAssoc("SELECT name,caption,kurs,data FROM {$structure} ORDER BY sort");
  }

  if($valutes)
  {
    reset($valutes);
	$_idv=A_Session::get('valute',key($valutes));

    foreach($valutes as $idv=>$vrow)
	{
	  $kurs=$valutes[$idv]['kurs'];
	  $pr=0;

      $_data=!empty($valutes[$idv]['data'])?unserialize($valutes[$idv]['data']):array();

      if(isset($_data[$data['idcat']]))
      { if(!empty($_data[$data['idcat']]['kurs']))
	    $kurs=(float)$_data[$data['idcat']]['kurs'];
	    if(!empty($_data[$data['idcat']]['per']))
	    $pr=(float)$_data[$data['idcat']]['per'];
      }
      else
	  { $idcat=$data['idcat'];
	    while($idcat)
	    { if(!isset($categories[$idcat]))
          $categories[$idcat]=A::$DB->getRowById($idcat,$section."_categories");
          $idcat=$categories[$idcat]['idker'];
		  if(isset($_data[$idcat]))
          { if(!empty($_data[$idcat]['kurs']))
		    $kurs=(float)$_data[$idcat]['kurs'];
		    if(!empty($_data[$idcat]['per']))
	        $pr=(float)$_data[$idcat]['per'];
	        break;
          }
        }
      }

      if($idv==$_idv)
      { $_kurs=$kurs;
        $_pr=$pr;
      }

      $idv=strtolower($idv);

	  $data['oldprice_'.$idv]=round($data['oldprice']*$kurs,2);
	  $data['price_'.$idv]=round($data['price']*$kurs,2);
	  
	  if(!empty($data['priceopt']))
	  $data['priceopt_'.$idv]=round($data['priceopt']*$kurs,2);
	  if(!empty($data['pricediler']))
	  $data['pricediler_'.$idv]=round($data['pricediler']*$kurs,2);
	  	  	  	  
	  if($pr)
	  { $data['oldprice_'.$idv]+=round($data['oldprice_'.$idv]*$pr/100,2);
	    $data['price_'.$idv]+=round($data['price_'.$idv]*$pr/100,2);
	    if(!empty($data['priceopt_'.$idv]))  
	    $data['priceopt_'.$idv]+=round($data['priceopt_'.$idv]*$pr/100,2);
	    if(!empty($data['pricediler_'.$idv]))
	    $data['pricediler_'.$idv]+=round($data['pricediler_'.$idv]*$pr/100,2);	    	    
	  }

      if(!empty($data['mprices']))
      foreach($data['mprices'] as $i=>$mp)
      { $data['mprices'][$i]['oldprice_'.$idv]=round($mp['oldprice']*$kurs,2);
	    $data['mprices'][$i]['price_'.$idv]=round($mp['price']*$kurs,2);
	    if($pr)
	    { $data['mprices'][$i]['oldprice_'.$idv]+=round($data['mprices'][$i]['oldprice_'.$idv]*$pr/100,2);
	      $data['mprices'][$i]['price_'.$idv]+=round($data['mprices'][$i]['price_'.$idv]*$pr/100,2);
	    }
      }
	}

    if(!empty($_kurs))
	{ $data['oldprice']=round($data['oldprice']*$_kurs,2);
	  $data['price']=round($data['price']*$_kurs,2);
	  if(!empty($data['priceopt']))
	  $data['priceopt']=round($data['priceopt']*$_kurs,2);
	  if(!empty($data['pricediler']))
	  $data['pricediler']=round($data['pricediler']*$_kurs,2);

	  if($_pr)
	  { $data['oldprice']+=round($data['oldprice']*$_pr/100,2);
	    $data['price']+=round($data['price']*$_pr/100,2);
	    if(!empty($data['priceopt']))  
	    $data['priceopt']+=round($data['priceopt']*$_pr/100,2);
	    if(!empty($data['pricediler']))
	    $data['pricediler']+=round($data['pricediler']*$_pr/100,2);	    	    
	  }

      if(!empty($data['mprices']))
      foreach($data['mprices'] as $i=>$mp)
      { $data['mprices'][$i]['oldprice']=round($mp['oldprice']*$_kurs,2);
	    $data['mprices'][$i]['price']=round($mp['price']*$_kurs,2);
	    if($_pr)
	    { $data['mprices'][$i]['oldprice']+=round($data['mprices'][$i]['oldprice']*$_pr/100,2);
	      $data['mprices'][$i]['price']+=round($data['mprices'][$i]['price']*$_pr/100,2);
	    }
      }
    }

  }

  return $data;
}

A::$OBSERVER->AddModifier('shoplite_prepareValues','valutes_prepareValues');

function valutes_CreatePage($template)
{
  if(A_MODE==A_MODE_FRONT && MODULE=='shoplite' && empty($_REQUEST['action']))
  { if($structure=getStructureByPlugin('valutes'))
    { if($valutes=A::$DB->getAssoc("SELECT name,caption,kurs,data FROM {$structure} ORDER BY sort"))
      { $idv=A_Session::get('valute',key($valutes));
	    if(isset($valutes[$idv]))
	    { A::$OPTIONS['valute']=$valutes[$idv]['caption'];
          if(A::$MAINFRAME->page=='result')
		  {
		    $kurs=$valutes[$idv]['kurs'];
	        $pr=0;

            if(!empty(A::$MAINFRAME->idcat))
			{ $idcat=A::$MAINFRAME->idcat;
			  $_data=!empty($valutes[$idv]['data'])?unserialize($valutes[$idv]['data']):array();
              if(isset($_data[$idcat]))
              { if(!empty($_data[$idcat]['kurs']))
	            $kurs=(float)$_data[$idcat]['kurs'];
	            if(!empty($_data[$idcat]['per']))
	            $pr=(float)$_data[$idcat]['per'];
              }
              else
	          { while($idcat)
	            { $idcat=A::$DB->getOne("SELECT idker FROM ".SECTION."_categories WHERE id=$idcat");
		          if(isset($_data[$idcat]))
                  { if(!empty($_data[$idcat]['kurs']))
		            $kurs=(float)$_data[$idcat]['kurs'];
		            if(!empty($_data[$idcat]['per']))
	                $pr=(float)$_data[$idcat]['per'];
	                break;
                  }
                }
              }
            }

			if(!empty($_GET['price_min']))
		    { if($pr)
		      $_GET['price_min']=round($_GET['price_min']*100/(100+$pr),2);
			  $_GET['price_min']=round($_GET['price_min']/$kurs,2);
		    }
		    if(!empty($_GET['price_max']))
		    { if($pr)
		      $_GET['price_max']=round($_GET['price_max']*100/(100+$pr),2);
			  $_GET['price_max']=round($_GET['price_max']/$kurs,2);
		    }
		  }
		}
	  }
	}
  }
}

A::$OBSERVER->AddHandler('CreatePage','valutes_CreatePage');

function valutes_Action($action)
{
  if(A_MODE==A_MODE_FRONT && $action=='setvalute' && !empty($_REQUEST['idv']))
  { A_Session::set('valute',preg_replace("/[^a-zA-Z0-9_-]/i","",$_REQUEST['idv']));
    A::goPrevUrl();
  }
}

A::$OBSERVER->AddHandler('Action','valutes_Action');

function valutes_ShowBlock($block,$data)
{
  if(strpos($block,'shoplite')===0)
  { if($structure=getStructureByPlugin('valutes'))
    { if($valutes=A::$DB->getAssoc("SELECT name,caption,kurs,data FROM {$structure} ORDER BY sort"))
      { $idv=A_Session::get('valute',key($valutes));
	    if(isset($valutes[$idv]))
	    { $data['object']->_tpl_vars['valute']=$valutes[$idv]['caption'];
	      $data['object']->_tpl_vars['options']['valute']=$valutes[$idv]['caption'];
	    }
	  }
	}
  }
}

A::$OBSERVER->AddHandler('ShowBlock','valutes_ShowBlock');

function valutes_SendOrder($template,$data)
{
  if(A_MODE==A_MODE_FRONT && MODULE=='shoplite' && ($template==A::$OPTIONS['mail_toadmin'] || $template==A::$OPTIONS['mail_touser']))
  {
    if(!$structure=getStructureByPlugin('valutes'))
    return;

    $basket=$data['object']->get_template_vars('basket');
    $all=$data['object']->get_template_vars('all');

	A::$DB->query("SELECT * FROM {$structure} ORDER BY sort");
    while($row=A::$DB->fetchRow())
	{
	  $valute=strtolower($row['name']);
	  $kurs=$row['kurs'];
	  $pr=0;
      $_data=!empty($row['data'])?unserialize($row['data']):array();
	  $all['sum_'.$valute]=0;

	  foreach($basket as $i=>$brow)
	  {
        if(isset($_data[$brow['data']['idcat']]))
        { if(!empty($_data[$brow['data']['idcat']]['kurs']))
	      $kurs=(float)$_data[$brow['data']['idcat']]['kurs'];
	      if(!empty($_data[$brow['data']['idcat']]['per']))
	      $pr=(float)$_data[$brow['data']['idcat']]['per'];
        }
        else
	    { $idcat=$brow['data']['idcat'];
	      while($idcat)
	      { if(!isset($categories[$idcat]))
            $categories[$idcat]=A::$DB->getRowById($idcat,SECTION."_categories");
            $idcat=$categories[$idcat]['idker'];
		    if(isset($_data[$idcat]))
            { if(!empty($_data[$idcat]['kurs']))
		      $kurs=(float)$_data[$idcat]['kurs'];
		      if(!empty($_data[$idcat]['per']))
	          $pr=(float)$_data[$idcat]['per'];
	          break;
            }
          }
        }

	    $basket[$i]['data']['price_'.$valute]=round($brow['data']['price']*$kurs,2);
	    if($pr)
	    $basket[$i]['data']['price_'.$valute]+=round($basket[$i]['data']['price_'.$valute]*$pr/100,2);

	    $basket[$i]['sum_'.$valute]=$basket[$i]['data']['price_'.$valute]*$brow['count'];

        $all['sum_'.$valute]+=$basket[$i]['sum_'.$valute];
      }

	}
	A::$DB->free();

	$data['object']->Assign("basket",$basket);
	$data['object']->Assign("all",$all);
  }
}

A::$OBSERVER->AddHandler('SendMail','valutes_SendOrder');