<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 " "
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Plugins
 */
/**************************************************************************/

if($base=A::$DB->getOne("SELECT name FROM ".A::$STRUCTURE." WHERE kurs=1"))
{
  if(extension_loaded('curl'))
  {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,"http://www.cbr.ru/scripts/XML_daily.asp");
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_USERAGENT, 'A.CMS');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $xml = curl_exec($ch);
    curl_close($ch);

    if(!$xml)
    return false;

    require_once 'XML/Unserializer.php';

    $unserializer = new XML_Unserializer();
    $unserializer->unserialize(mb_convert_encoding($xml,"UTF-8","Windows-1251"));

    if($xml=$unserializer->getUnserializedData())
    {
	  $valutes=array('rur'=>1);
      if(!empty($xml['Valute']))
      foreach($xml['Valute'] as $data)
      $valutes[strtolower($data['CharCode'])]=((float)str_replace(",",".",$data['Value']))/$data['Nominal'];

	  $base=strtolower($base);

	  if($val=!empty($valutes[$base])?$valutes[$base]:0)
	  { foreach($valutes as $id=>$value)
        $valutes[$id]=$value?$val/$value:0;

		A::$DB->query("SELECT id,name,data FROM ".A::$STRUCTURE." WHERE kurs<>1");
		while($row=A::$DB->fetchRow())
		if(isset($valutes[$id=strtolower($row['name'])]))
		{ $data=!empty($row['data'])?unserialize($row['data']):array();
		  foreach($data as $idcat=>$vdata)
		  $data[$idcat]['kurs']=round($valutes[$id],4);
		  A::$DB->Update(A::$STRUCTURE,array('kurs'=>round($valutes[$id],4),'data'=>!empty($data)?serialize($data):""),"id=".$row['id']);
		}
		A::$DB->free();
      }
    }
  }
}